var _devNum = -1;
var _devInfos = null;
var _myWs = new MzWsConnect(location.port, onTxtMessage, onError, ClearOutputInfo);

/**
 * 处理服务器文本消息
 */
function onTxtMessage(msg) {
    var jsonObj = JSON.parse(msg);
    if (jsonObj.result != 0 && jsonObj.result != 9) {
        // 返回result=0表示执行成功,其他值表示异常。9表示：设备使用中，打开摄像头时忽略这个异常
        console.log(jsonObj.func, jsonObj.errorMsg);
        displayOutputInfo(3, jsonObj.func + "    " + jsonObj.errorMsg)
        if (jsonObj.func == "FaceMatch") {
            var btn = document.getElementById("btnStartStop");
            btn.innerText = Lang.IDC.startCompare;
        }
    } else {
        switch (jsonObj.func) {
            case "GetCameraVideoBuff":
                DisplayVideo(jsonObj);
                break;
            case "GetCameraInfo":
                DisplayDevInfo(jsonObj);
                break;
            case "GetAudioDevInfo":
                DisplayAudioDevInfo(jsonObj);
                break;
            case "CameraCaptureBase64":
                DisplayCaptureFile(jsonObj);
                break;
            case "RecordVideo":
                DisplayRecordVideoResult(jsonObj);
                break;
            case "ReadIDCardInfo":
                DisplayIDCardInfo(jsonObj);
                break;
            case "CloseCamera":
                document.getElementById("videoMain").src = "";
                break;
            case "Notify":
                // 收到通知
                if (jsonObj.event == "OnUsbKeyPress") {
                    // 收到USB按键按下的通知
                    // {func:"Notify","event":"OnUsbKeyPress","reqId":1636099207839.0,"result":0,"time":"1636099214"}
                    // DisplayUsbKeyPress(jsonObj);
                } else if (jsonObj.event == "OnDeviceChanged") {
                    // 设备有变化,格式如下:
                    // {func:"Notify","event":"OnDeviceChanged","devName":"\\\\?\\USB#VID_0C45&PID_6366...",func:"OnDeviceChanged","result":0,"type":1}
                    // type: 1设备插入; 2设备已拔出
                    Wait1secGetCameraInfo();
                }
                break;
        }
    }
}

// 处理连接错误
function onError(e, msg) {
    displayOutputInfo(3, msg);
}

function ClearOutputInfo() {
    displayOutputInfo(0);
}

var _tdOpration = '<a onclick="vf()">播放</a> <a onclick="df()">删除</a>';
var _tdRecording = '录制中...';
function displayFile(file, finished) {
    if (finished) {
        var trs = $("#tabBody>tr");
        for (var i = 0; i < trs.length; i++) {
            if (trs[i].dataset['fn'] == file) {
                trs[i].children[1].innerHTML = _tdOpration;
                break;
            }
        }
    } else {
        var pos = file.lastIndexOf('\\');
        var html = '<tr data-fn="' + file + '"><td>' + file.substring(pos + 1) + '</td><td>' + (finished ? _tdOpration : _tdRecording) + '</td></tr>';
        $("#tabBody").append(html);
    }
}

function vf() {
    var e = e || window.event;
    var target = e.target || e.srcElement;
    var file = $(target).parent().parent().data('fn');
    var pos = file.lastIndexOf('\\');
    var pos2 = file.lastIndexOf('\\', pos - 1);
    var subPath = file.substring(pos2);
    var url = location.origin + '/tmp/' + subPath.replaceAll('\\', '/');
    document.getElementById("videoPlayer").src = url;
    $('#myModal').modal();
}

function onClosePlayer() {
    document.getElementById("videoPlayer").src = "";
}

// 删除视频文件
function df() {
    var e = e || window.event;
    var target = e.target || e.srcElement;
    $(target).parent().parent().remove();
}

// 删除全部视频文件
function clearVideoFile() {
    $("#tabBody").empty();
}

function SetCameraInfo() {
    var rotateAngle = parseInt($("#rotateType").val());
    displayOutputInfo(0);
    _myWs.SendJson({func:"SetCameraImageInfo", devNum:_devNum, rotate:rotateAngle, reqId: new Date().getTime()});
}

// 打开(1)或关闭(0)人像摄像头,无参数时根据按钮上的文字确定
function OpenCloseCamera(isOpen) {
    var open = false;
    var obj = document.getElementById("btnOpenClose");
    if (typeof(isOpen) == "undefined") {
        open = obj.innerText != "关闭摄像头";
    } else {
        open = isOpen != 0;
    }
    var now = new Date().getTime();
    if (_devNum >= 0) {
        // 打开过先关闭,关闭前先停掉视频
        _myWs.SendJson({func:"GetCameraVideoBuff", devNum:_devNum, enable:false, reqId: now++});
        _myWs.SendJson({func:"CloseCamera", devNum:_devNum, reqId: now++});
        _devNum = -1;
        obj.innerText = "打开摄像头";
    }
    if (open) {
        _devNum = parseInt($("#camMain2").val());
        var resolutionNum = parseInt($("#resMain2").val());
		
		var resolutions = _devInfos[0].mediaTypes[0].resolutions;
		var res = resolutions[resolutionNum].split('x');
		var width = parseInt(res[0]);
		var height = parseInt(res[1]);
		
        _myWs.SendJson({func:"OpenCamera", devNum:_devNum, mediaNum:0, width:width, height:height, resolutionNum:resolutionNum, reqId: now++});
        _myWs.SendJson({func:"GetCameraVideoBuff", devNum:_devNum, enable:true, reqId: now++});
        SetCameraInfo();
        obj.innerText = "关闭摄像头";
    }
}

function displayOutputInfo(disp, s, add) {
    if (disp > 0 && disp < 4) {
        var ary = ["info", "success", "warning"];
        var h = "<b>" + s + "</b>";
        if (add) {
            var h0 = $('#outInfo').html();
            if (h0.length > 0) {
                h = h0 + "<br>" + h;
            }
        }
        $('#outInfo').css("display", "").attr("class", "col-md-12 alert alert-" + ary[disp - 1]).html(h);
    } else {
        $('#outInfo').css("display", "none").html("");
    }
}

function DisplayRecordVideoResult(v) {
    if (v.stop) {
        displayFile(v.savePath, 1);
        // 启用【开始录制】按钮
        $("#btnStartRecord").removeAttr("disabled");
    } else {
        displayFile(v.savePath, 0);
        // 5秒后允许停止
        window.setTimeout(function(){
            $("#btnStopRecord").removeAttr("disabled");
        },5000);
    }
}

function startRecord() {
    var mainIdx = parseInt($("#camMain").val());
    var viceIdx = parseInt($("#camVice").val());
    if (mainIdx == viceIdx) {
        displayOutputInfo(3, '录像时主摄像头与副摄像头不能是同一个设备.');
    } else {
        $("#btnStartRecord").attr('disabled', 'disabled');
        var res = $("#resMain").find("option:selected").text();
        var ary = res.split('x');
        var mainWidth = parseInt(ary[0]);
        var mainHeight = parseInt(ary[1]);
        _myWs.SendJson({"func": "RecordVideo",
                                "mainCamIndex": mainIdx,
                                "mainWidth": mainWidth,
                                "mainHeight": mainHeight,
                                "viceCamIndex": viceIdx,
                                "savePath": $("#savePath").val(),
                                "viceWidth": parseInt($("#viceWidth").val()),
                                "vicePosX": parseInt($("#vicePosX").val()),
                                "vicePosY": parseInt($("#vicePosY").val()),
                                "audioDevIndex": parseInt($("#audioDev").val()),
                                "bitrateKbps": parseInt($("#bitrate").val()),
                                "switchMainVideo": $("#switchMainVideo")[0].checked,
                                reqId: new Date().getTime()});
    }
}

function stopRecord() {
    $("#btnStopRecord").attr('disabled', 'disabled');
    _myWs.SendJson({"func": "RecordVideo", "stop": true, reqId: new Date().getTime()});
}

var _w = 0, _h = 0;
function DisplayVideo(v) {
    if (v.width) {
        if (_w != v.width || _h != v.height) {
            //设置视频显示的宽高（宽度控制为640px）
            $("#video").css('width', '640px').css('height', 640 * v.height / v.width + 'px');
            _w = v.width, _h = v.height;
        }
        //显示视频
        document.getElementById("videoMain").src = "data:" + v.mime + ";base64," + v.imgBase64Str;
    }
}

// 刷新显示 分辨率下拉列表
function displayResolution(sn) {
    var index1 = document.getElementById("camMain" + (sn==1 ? "" : "2")).options.selectedIndex;
    var obj = document.getElementById("resMain" + (sn==1 ? "" : "2"));
    var resolutions = _devInfos[index1].mediaTypes[0].resolutions;
    obj.options.length = 0;
    var sel = 0;
    for (var i = 0; i < resolutions.length; i++) {
        obj.options.add(new Option(resolutions[i], i));
        if (parseInt(resolutions[i].split('x')) > 2000) {
            // 考虑录制性能，禁用2000以上的分辨率
            obj.options[i].disabled = true;
        } else if (sel == 0) {
            obj.options[i].selected = true;
            sel = 1;
        }
    }
}

// 刷新显示 设备名称 下拉列表
function displayCamera() {
    var obj = document.getElementById("camMain");
    var obj2 = document.getElementById("camMain2");
    var obj3 = document.getElementById("camVice");
    var lastSelectedIndex1 = obj.options.selectedIndex;
    var lastSelectedIndex2 = obj2.options.selectedIndex;
    var lastSelectedIndex3 = obj3.options.selectedIndex;
    obj.options.length = 0;
    obj2.options.length = 0;
    obj3.options.length = 0;
    obj3.options.add(new Option("<不使用>", -1));
    for (var i = 0; i < _devInfos.length; i++) {
        obj.options.add(new Option(_devInfos[i].devName, _devInfos[i].id));
        obj2.options.add(new Option(_devInfos[i].devName, _devInfos[i].id));
        obj3.options.add(new Option(_devInfos[i].devName, _devInfos[i].id));
    }
    if (lastSelectedIndex1 >= 0 && lastSelectedIndex1 < _devInfos.length) {
        obj.options.selectedIndex = lastSelectedIndex1;
    }
    if (lastSelectedIndex2 >= 0 && lastSelectedIndex2 < _devInfos.length) {
        obj2.options.selectedIndex = lastSelectedIndex2;
    }
    if (lastSelectedIndex3 >= 0 && lastSelectedIndex3 < _devInfos.length) {
        obj3.options.selectedIndex = lastSelectedIndex3;
    }
}

function DisplayDevInfo(v) {
    if (v.result == 0) {
        _devInfos = v.devInfo;
        if (_devInfos.length == 0) {
            displayOutputInfo(3, "获取设备信息时，返回的devInfos为空.");
            return;
        }
        displayCamera();
        displayResolution(1);
        displayResolution(2);
    } else {
        displayOutputInfo(3, v.func + "<br>" + v.errorMsg);
    }
}

function DisplayAudioDevInfo(v) {
    var obj = document.getElementById("audioDev");
    var lastSelectedIndex = obj.options.selectedIndex;
    obj.options.length = 0;
    obj.options.add(new Option("<不使用>", -1));
    for (var i = 0; i < v.microphones.length; i++) {
        obj.options.add(new Option(v.microphones[i], i));
    }
    if (lastSelectedIndex >= 0 && lastSelectedIndex < v.microphones.length) {
        obj.options.selectedIndex = lastSelectedIndex;
    }
}

$(function () {
    // 获取设备信息
    var now = new Date().getTime();
    _myWs.SendJson({func:"GetCameraInfo", reqId: now++});
    _myWs.SendJson({func:"GetAudioDevInfo", reqId: now++});
});

$(window).unload(function(){
    // 关闭页面之前,关闭摄像头
    if (_devNum >= 0) {
        OpenCloseCamera(0);
    }
});
