var _myWs = new MzWsConnect(location.port, onTxtMessage, onError, ClearOutputInfo);

// 处理连接错误
function onError(e, msg) {
    displayOutputInfo(3, msg);
}

// 处理服务器二进制消息
function onBinMessage(e) {
    console.log('onBinMessage', e);
}

function ClearOutputInfo() {
    displayOutputInfo(0);
}

// 处理接收到的服务器文本消息
function onTxtMessage(msg) {
    var jsonObj = JSON.parse(msg);
    if (jsonObj.result != 0) {
        console.log(jsonObj.functionName, jsonObj.errorMsg);
        var info = "";
        if (jsonObj.result) {
            info += "<br>维山错误代码: " + jsonObj.result + ", 错误信息: " + jsonObj.errorMsg;
        }
        displayOutputInfo(3, info);
    } else {
        switch (jsonObj.func) {
            case "Notify":
                displayInfo(jsonObj);
                break;
            case "BarcodeScanner":
                displayDevSN(jsonObj.devSN);
            case "ReadBarcodeScanerDevSN":
                displayDevSN(jsonObj.devSN);
                break;
            default:
                displayOutputInfo(1, msg);
                break;
        }
    }
}

function startReadData(){
    _myWs.SendJson({func: 'BarcodeScanner', enable: 1, reqId: new Date().getTime()});
}

function stopReadData(){
    _myWs.SendJson({func: 'BarcodeScanner', enable: 0, reqId: new Date().getTime()});
    document.getElementById('barCodeInfo').textContent = "";
}

function getHidDevSn(){
    _myWs.SendJson({func: 'ReadBarcodeScanerDevSN', reqId: new Date().getTime()});
}

function displayDevSN(sn){
    document.getElementById('devSN').value = typeof(sn) == 'undefined' ? "" : sn;
}

function displayInfo(obj){
    if (obj.event == 'OnReceivePosData') {
        document.getElementById('barCodeInfo').textContent = obj.data;
    }
}

function displayOutputInfo(disp, s) {
    if (disp > 0 && disp < 4) {
        var ary = ["info", "success", "warning"];
        $('#outInfo').css("display", "").attr("class", "col-md-12 alert alert-" + ary[disp - 1]).html("<b>" + s + "</b>");
    } else {
        $('#outInfo').css("display", "none").html("");
    }
}

$(window).unload(function () {
    // 关闭页面之前,关闭连接
    _myWs.Close();
});